from resources.lib.modules.addon import Addon
from resources.lib.modules import client
from resources.lib.modules import control
from resources.lib.modules.log_utils import log
import os,re,sys,urlparse,xbmcplugin,xbmc,datetime,xbmcgui
from random import randint


addon = Addon('plugin.image.garfield_comic', sys.argv)
addon_handle = int(sys.argv[1])

AddonPath = addon.get_path()
fanart = os.path.join(AddonPath + "/fanart.jpg")
icon = os.path.join(AddonPath + "/icon.png")

today = os.path.join(AddonPath + "/resources/media/today.png")
recent = os.path.join(AddonPath + "/resources/media/recent.png")
random = os.path.join(AddonPath + "/resources/media/random.png")
date = os.path.join(AddonPath + "/resources/media/date.png")
next = os.path.join(AddonPath + "/resources/media/next.png")

args = urlparse.parse_qs(sys.argv[2][1:])
mode = args.get('mode', None)


xbmcplugin.setContent(addon_handle, 'pictures')


def add_image(image):
    item = xbmcgui.ListItem(image['name'])
    item.setArt({'thumb': image['thumb_url'],
    			'fanart':fanart})
    item.setInfo(
        type='pictures',
        infoLabels={
            "title": image['name'],
            "picturepath": image['url'],
            "exif:path": image['url']
        }
    )

    xbmcplugin.addDirectoryItem(addon_handle, image['url'], item)

if mode is None:

	addon.add_item({'mode': 'today'}, {'title':'Today\'s comic'}, img=today, fanart=fanart)
	addon.add_item({'mode': 'last_week','page':'1'}, {'title':'Recent comics'}, img=recent, fanart=fanart,is_folder=True)
	addon.add_item({'mode': 'random'}, {'title':'Random comics'}, img=random, fanart=fanart,is_folder=True)
	addon.add_item({'mode': 'enter'}, {'title':'Open specific date'}, img=date, fanart=fanart,is_folder=True)
	control.directory(addon_handle,cacheToDisc=False)

elif mode[0]=='today':
	now = datetime.datetime.now()
	year=now.strftime("%Y")
	month=now.strftime("%m")
	day=now.strftime("%d")
	url='https://d1ejxu6vysztl5.cloudfront.net/comics/garfield/%s/%s-%02d-%02d.gif'%(int(year),int(year),int(month),int(day))
	xbmc.executebuiltin("ShowPicture(%s)"%url)
	
elif mode[0]=='last_week':
	page = args['page'][0]
	now = datetime.datetime.now()
	year=now.strftime("%Y")
	month=now.strftime("%m")
	day=now.strftime("%d")

	offset = 200 * (int(page)-1) * 24
	now  = datetime.datetime.now() - datetime.timedelta(hours=(24 + offset))
	



	for i in range(200):
		year=now.strftime("%Y")
		month=now.strftime("%m")
		day=now.strftime("%d")
		pom=year+'-'+month+'-'+day
		uroo='https://d1ejxu6vysztl5.cloudfront.net/comics/garfield/%s/%s-%02d-%02d.gif'%(int(year),int(year),int(month),int(day))
		add_image({'url':uroo,'thumb_url':uroo,'name':'%s/%s/%s'%(year,month,day)})
		now=now-datetime.timedelta(hours=24)

	addon.add_item({'mode': 'last_week','page':'%s'%(int(page)+1)}, {'title':'Next Page >>'}, img=next, fanart=fanart,is_folder=True)

	xbmcplugin.endOfDirectory(addon_handle)
		


elif mode[0]=='view':
	dicti=urlparse.parse_qs(sys.argv[2][1:])
	link=dicti['link'][0]
	print(link)
	xbmc.executebuiltin("ShowPicture(%s)"%link)





elif mode[0]=='random':
	for i in range(200):
		yy=randint(1978,2016)
		mm=randint(1,12)
	 	dd=randint(1,31)
	 	y=str(yy)
	 	m = '%02d'%mm
	 	d = '%02d'%dd
	 	random= '%s-%s-%s'%(y,m,d)
		uroo=url='https://d1ejxu6vysztl5.cloudfront.net/comics/garfield/%s/%s.gif'%(y,random)
		add_image({'url':uroo,'thumb_url':uroo,'name':'%s/%s/%s'%(y,m,d)})

	addon.add_item({'mode': 'random'}, {'title':'Next Page >>'}, img=next, fanart=fanart,is_folder=True)

	xbmcplugin.endOfDirectory(addon_handle)

                                     	
elif mode[0]=='enter':
	keyboard = xbmc.Keyboard('', 'Enter date(yyyy-mm-dd)', False)
	keyboard.doModal()
	if keyboard.isConfirmed():
		date = keyboard.getText()

		year,month,day = date.split('-')
		url='https://d1ejxu6vysztl5.cloudfront.net/comics/garfield/%s/%s-%02d-%02d.gif'%(int(year),int(year),int(month),int(day))
		
		xbmc.executebuiltin("ShowPicture(%s)"%url)
		